Coin: SoVRMLDragSensor Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Static Protected Member Functions | List of all members
SoVRMLDragSensor Class Referenceabstract

The SoVRMLDragSensor class is a superclass for VRML drag sensors. More...

`#include <Inventor/VRMLnodes/SoVRMLDragSensor.h>`

Inheritance diagram for SoVRMLDragSensor:

## Public Member Functions
virtual SoType | getTypeId (void) const
virtual void | handleEvent (SoHandleEventAction *action)
Public Member Functions inherited from SoVRMLSensor
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | pick (SoPickAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
SbUniqueId | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoVRMLSensor
static SoType | getClassTypeId (void)
static void | initClass (void)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes
SoSFVec3f | trackPoint_changed
SoSFBool | autoOffset
Public Attributes inherited from SoVRMLSensor
SoSFBool | isActive
SoSFBool | enabled
Public Attributes inherited from SoBase

## Protected Member Functions
virtual const SoFieldData * | getFieldData (void) const
virtual SbBool | dragStart (void)=0
virtual void | drag (void)=0
virtual void | dragFinish (void)=0
| SoVRMLDragSensor (void)
virtual | ~SoVRMLDragSensor ()
const SbVec3f & | getLocalStartingPoint (void) const
const SbMatrix & | getLocalToWorldMatrix (void) const
const SbMatrix & | getWorldToLocalMatrix (void) const
const SbViewVolume & | getViewVolume (void) const
const SbVec2f & | getNormalizedLocaterPosition (void) const
Protected Member Functions inherited from SoVRMLSensor
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoVRMLSensor
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 , INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 , COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 , COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 , COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000 }
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoVRMLDragSensor class is a superclass for VRML drag sensors.

This class collects the two fields that are common for some of the sensor nodes, plus some common functions for these. Since this is an abstract "helper" class, it does not represent an actual node from the VRML97 specification, so don't use it as such.

For more information, a detailed discussion of drag sensors is available in section 4.6.7.4 of the VRML97 specification:

http://www.web3d.org/documents/specifications/14772/V2.0/part1/concepts.html#4.6.7.4.

## Constructor & Destructor Documentation

## ◆ SoVRMLDragSensor()

SoVRMLDragSensor::SoVRMLDragSensor | ( | void |  | ) |
| protected

Constructor.

## ◆ ~SoVRMLDragSensor()

SoVRMLDragSensor::~SoVRMLDragSensor | ( |  | ) |
| protectedvirtual

Destructor.

## Member Function Documentation

## ◆ getClassTypeId()

SoType SoVRMLDragSensor::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ getTypeId()

SoType SoVRMLDragSensor::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoVRMLSensor.

Reimplemented in SoVRMLCylinderSensor, SoVRMLPlaneSensor, and SoVRMLSphereSensor.

## ◆ getFieldDataPtr()

const SoFieldData ** SoVRMLDragSensor::getFieldDataPtr | ( | void |  | ) |
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## ◆ getFieldData()

const SoFieldData * SoVRMLDragSensor::getFieldData | ( | void |  | ) | const
| protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoVRMLSensor.

Reimplemented in SoVRMLCylinderSensor, SoVRMLPlaneSensor, and SoVRMLSphereSensor.

## ◆ handleEvent()

void SoVRMLDragSensor::handleEvent | ( | SoHandleEventAction * | action | ) |
| virtual

Action method for SoHandleEventAction.

Inspects the event data from action, and processes it if it is something which this node should react to.

Nodes influencing relevant state variables for how event handling is done also override this method.

Reimplemented from SoNode.

## ◆ initClass()

void SoVRMLDragSensor::initClass | ( | void |  | ) |
| static

## ◆ dragStart()

virtual SbBool SoVRMLDragSensor::dragStart | ( | void |  | ) |
| protectedpure virtual

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when dragger is selected (picked) by the user.

Implemented in SoVRMLCylinderSensor, SoVRMLPlaneSensor, and SoVRMLSphereSensor.

## ◆ drag()

virtual void SoVRMLDragSensor::drag | ( | void |  | ) |
| protectedpure virtual

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when user drags the mouse after picking the dragger.

Implemented in SoVRMLCylinderSensor, SoVRMLPlaneSensor, and SoVRMLSphereSensor.

## ◆ dragFinish()

virtual void SoVRMLDragSensor::dragFinish | ( | void |  | ) |
| protectedpure virtual

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when mouse button is released after picking and interacting with the dragger.

Implemented in SoVRMLCylinderSensor, SoVRMLPlaneSensor, and SoVRMLSphereSensor.

## ◆ getLocalStartingPoint()

const SbVec3f & SoVRMLDragSensor::getLocalStartingPoint | ( | void |  | ) | const
| protected

Returns the interaction starting point.

## ◆ getLocalToWorldMatrix()

const SbMatrix & SoVRMLDragSensor::getLocalToWorldMatrix | ( | void |  | ) | const
| protected

Returns the matrix that transforms to the world coordinate system.

## ◆ getWorldToLocalMatrix()

const SbMatrix & SoVRMLDragSensor::getWorldToLocalMatrix | ( | void |  | ) | const
| protected

Returns the matrix that transforms from the world coordinate system.

## ◆ getViewVolume()

const SbViewVolume & SoVRMLDragSensor::getViewVolume | ( | void |  | ) | const
| protected

Returns the current view volume.

## ◆ getNormalizedLocaterPosition()

const SbVec2f & SoVRMLDragSensor::getNormalizedLocaterPosition | ( | void |  | ) | const
| protected

Returns the current normalized pointer position.

## Member Data Documentation

## ◆ trackPoint_changed

SoSFVec3f SoVRMLDragSensor::trackPoint_changed

An event out that is generated when the trackpoint is changed.

## ◆ autoOffset

SoSFBool SoVRMLDragSensor::autoOffset

When `TRUE`, the offset field is updated when a dragging sequence is finished. Default value is `TRUE`.

The documentation for this class was generated from the following files:

- SoVRMLDragSensor.h
- DragSensor.cpp